;;; untested file to set unipress-like key bindings.  from netnews.

(defun set-unipress-bindings ()
  (interactive)
; (global-set-key "\^c"    'save-buffers-kill-emacs)
  (global-set-key "\^x\^e" 'compile)
  (global-set-key "\^x\^f" 'save-buffers-kill-emacs)
  (global-set-key "\^X\^I" 'insert-file)
  (global-set-key "\^X\^M" 'save-some-buffers)
  (global-set-key "\^X\^N" 'next-error)
  (global-set-key "\^X\^O" 'switch-to-buffer)
  (global-set-key "\^X\^R" 'insert-file)
  (global-set-key "\^X\^U" 'advertised-undo)
  (global-set-key "\^X\^V" 'find-file-other-window)
  (global-set-key "\^X\^Z" 'shrink-window)
  (global-set-key "\^X!"   'shell-command)
  (global-set-key "\^Xd"   'delete-window)
  (global-set-key "\^Xn"   'unipress-next-window)
  (global-set-key "\^Xp"   'unipress-previous-window)
  (global-set-key "\^Xz"   'enlarge-window)
  (global-set-key "\^Z"    'scroll-one-line-up)
  (global-set-key "\e\^C"  'save-buffers-kill-emacs)
  (global-set-key "\e!"    'line-to-top-of-window)
  (global-set-key "\e("    'backward-paragraph)
  (global-set-key "\e)"    'forward-paragraph)
  (global-set-key "\e?"    'apropos)
  (global-set-key "\eh"    'delete-previous-word)
  (global-set-key "\ej"    'indent-sexp)
  (global-set-key "\eq"    'query-replace)
  (global-set-key "\er"    'replace-string)
  (global-set-key "\ez"    'scroll-one-line-down)
  (global-set-key "\^_"    'suspend-emacs))

(defun set-gnu-bindings ()
  (interactive)
  (global-set-key "\^c"    'exit-recursive-edit)
  (global-set-key "\^x\^e" 'eval-last-sexp)
  (global-set-key "\^x\^f" 'find-file)
  (global-set-key "\^X\^I" 'indent-rigidly)
  (global-unset-key "\^X\^M")
  (global-set-key "\^X\^N" 'set-goal-column)
  (global-set-key "\^X\^O" 'delete-blank-lines)
  (global-set-key "\^X\^R" 'find-file-read-only)
  (global-set-key "\^X\^U" 'upcase-region)
  (global-set-key "\^X\^V" 'find-alternate-file)
  (global-set-key "\^X\^Z" 'suspend-emacs)
  (global-unset-key "\^X!")
  (global-set-key "\^Xd"   'dired)
  (global-set-key "\^Xn"   'narrow-to-region)
  (global-set-key "\^Xp"   'narrow-to-page)
  (global-unset-key "\^Xz")
  (global-set-key "\^Z"    'suspend-emacs)
  (global-set-key "\e\^C"  'exit-recursive-edit)
  (global-set-key "\e!"    'shell-command)
  (global-set-key "\e("    'insert-parentheses)
  (global-set-key "\e)"    'move-past-close-and-reindent)
  (global-unset-key "\e?")
  (global-set-key "\eh"    'mark-paragraph)
  (global-set-key "\ej"    'indent-new-comment-line)
  (global-set-key "\eq"    'fill-paragraph)
  (global-set-key "\er"    'move-to-window-line)
  (global-set-key "\ez"    'zap-to-char)
  (global-unset-key "\^_"))

(defun unipress-previous-window ()
  (interactive)
  (select-window (previous-window)))

(defun unipress-next-window ()
  (interactive)
  (select-window (next-window)))

(defun scroll-one-line-up ()
  (interactive)
  (scroll-up 1))

(defun scroll-one-line-down ()
  (interactive)
  (scroll-down 1))

(defun line-to-top-of-window ()
  (interactive)
  (recenter 0))
